WT_ZoningTimeFix = {};
WT_ZoningTimeFix.Addons = {};
WT_ZoningTimeFix.CapturedFrames = {};
WT_ZoningTimeFix.SuppressedEvents = {};

function WT_ZoningTimeFix_OnLoad()
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PLAYER_LEAVING_WORLD");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_LOGIN");
end

function WT_ZoningTimeFix_OnEvent()
	for suppressedEvent, _ in WT_ZoningTimeFix.SuppressedEvents do
		if (event == suppressedEvent) then
			WT_ZoningTimeFix.SuppressedEventsFired(event);
			break;
		end
	end
	if (event == "PLAYER_LEAVING_WORLD") then
		local frame, events;
		for frame, events in WT_ZoningTimeFix_SavedFrames do
			if type(getglobal(frame)) == "table" and (type(getglobal(frame).RegisterEvent) == "function") then
				local Event;
				for _, Event in events do
					getglobal(frame):UnregisterEvent(Event);
				end
			end
		end
		local addonName, addon;
		for addonName, addon in WT_ZoningTimeFix.Addons do
			if IsAddOnLoaded(addonName) then
				local frame, events;
				for frame, events in addon.Frames do
					if type(getglobal(frame)) == "table" and type(events) == "table" then
						local Event;
						for _, Event in events do
							if Event then
								getglobal(frame):UnregisterEvent(Event);
							end
						end
					end
				end
			end
		end
	elseif (event == "PLAYER_ENTERING_WORLD") then
		--DEFAULT_CHAT_FRAME:AddMessage("WT_ZoningTimeFix: PLAYER_ENTERING_WORLD") -- debug
		local frame, events;
		for frame, events in WT_ZoningTimeFix_SavedFrames do
			if (type(getglobal(frame)) == "table") and (type(getglobal(frame).RegisterEvent) == "function") then
				local Event;
				for _, Event in events do
					getglobal(frame):RegisterEvent(Event);
				end
			end
		end
		local addonName, addon;
		for addonName, addon in WT_ZoningTimeFix.Addons do
			if IsAddOnLoaded(addonName) then
				local frame, events;
				for frame, events in addon.Frames do
					if type(getglobal(frame)) == "table" and type(events) == "table" then
						local Event;
						for _, Event in events do
							if Event then
								getglobal(frame):RegisterEvent(Event);
							end
						end
					end
				end
				if addon.Update then
					for _, updates in addon.Update do
						if updates and type(updates.func) == "function" and type(updates.args) == "table" then
							for frame, events in addon.Frames do
								for _, Event in events do
									event = Event;
									updates.func(unpack(updates.args));
								end
							end
						end
					end
				end
			end
		end
		-- restore event
		event = "PLAYER_ENTERING_WORLD";
	elseif (event == "PLAYER_LOGIN") then
		-- initialize suppressed events list and count
		WT_ZoningTimeFix.SuppressedEvents = {
			["ACTIONBAR_SLOT_CHANGED"] = 0,
			["BAG_UPDATE"] = 0,
			["ITEM_LOCK_CHANGED"] = 0,
			["UNIT_INVENTORY_CHANGED"] = 0,
		};
		WT_ZoningTimeFix.SuppressedEventsCount = 0;
		for suppressedEvent, _ in WT_ZoningTimeFix.SuppressedEvents do
			WT_ZoningTimeFix.SuppressedEventsCount = WT_ZoningTimeFix.SuppressedEventsCount + 1;
			this:RegisterEvent(suppressedEvent);
		end
		-- add suppressed event catcher to all frame's OnEvent handler
		WT_ZoningTimeFix.InjectEventCatcher();
	elseif (event == "VARIABLES_LOADED") then
		--DEFAULT_CHAT_FRAME:AddMessage("WT_ZoningTimeFix: VARIABLES_LOADED") -- debug
		if not WT_ZoningTimeFix_SavedFrames then
			WT_ZoningTimeFix_SavedFrames = WT_ZoningTimeFix.CapturedFrames;
		end
		if IsAddOnLoaded("Perl_CombatDisplay") then
			-- Perl Classic CombatDisplay
			WT_ZoningTimeFix.Addons["Perl_CombatDisplay"] = {
			    Frames = {
			        ["Perl_CombatDisplay_Frame"] = {"UNIT_HEALTH", "UNIT_MANA", "UNIT_AURA", "UNIT_RAGE", "UNIT_ENERGY", "UNIT_FOCUS"},
			    },
			};
		end
		if IsAddOnLoaded("Perl_Party") then
			-- Perl Classic Party
			WT_ZoningTimeFix.Addons["Perl_Party"] = {
			    Frames = {
			        ["Perl_Party_MemberFrame1"] = {"UNIT_HEALTH", "UNIT_MANA", "UNIT_AURA", "UNIT_RAGE", "UNIT_ENERGY"},
			        ["Perl_Party_MemberFrame2"] = {"UNIT_HEALTH", "UNIT_MANA", "UNIT_AURA", "UNIT_RAGE", "UNIT_ENERGY"},
			        ["Perl_Party_MemberFrame3"] = {"UNIT_HEALTH", "UNIT_MANA", "UNIT_AURA", "UNIT_RAGE", "UNIT_ENERGY"},
			        ["Perl_Party_MemberFrame4"] = {"UNIT_HEALTH", "UNIT_MANA", "UNIT_AURA", "UNIT_RAGE", "UNIT_ENERGY"},
			    },
			};
		end
		if IsAddOnLoaded("Perl_Player") then
			-- Perl Classic Player
			WT_ZoningTimeFix.Addons["Perl_Player"] = {
			    Frames = {
			        ["Perl_Player_Frame"] = {"UNIT_HEALTH", "UNIT_MANA", "UNIT_AURA", "UNIT_RAGE", "UNIT_ENERGY"},
			    },
			};
		end
		if IsAddOnLoaded("Perl_Player_Pet") then
			-- Perl Classic Player Pet
			WT_ZoningTimeFix.Addons["Perl_Player_Pet"] = {
			    Frames = {
			        ["Perl_Player_Pet_Frame"] = {"UNIT_HEALTH", "UNIT_MANA", "UNIT_AURA", "UNIT_RAGE", "UNIT_ENERGY", "UNIT_FOCUS"},
			    },
			};
		end
		if IsAddOnLoaded("Perl_Target") then
			-- Perl Classic Target
			WT_ZoningTimeFix.Addons["Perl_Target"] = {
			    Frames = {
			        ["Perl_Target_Frame"] = {"UNIT_HEALTH", "UNIT_MANA", "UNIT_AURA", "UNIT_RAGE", "UNIT_ENERGY", "UNIT_FOCUS"},
			    },
			};
		end
		if IsAddOnLoaded("BeneCast") then
			-- BankItems
			WT_ZoningTimeFix.Addons["BeneCast"] = {
			    Frames = {
			        ["BeneCastPanelManager"] = {"UNIT_AURA", "UNIT_HEALTH"},
			    },
			};
		end
		if IsAddOnLoaded("ArcHUD") then
			-- ArcHUD
			WT_ZoningTimeFix.Addons["ArcHUD"] = {
			    Frames = {
			        ["ArcHUDFrame"] = {"UNIT_HEALTH", "UNIT_MANA", "UNIT_AURA", "UNIT_RAGE", "UNIT_ENERGY", "UNIT_FOCUS"},
			        ["ArcHUDRing_Health"] = {"UNIT_HEALTH"},
			        ["ArcHUDRing_Mana"] = {"UNIT_MANA", "UNIT_RAGE", "UNIT_ENERGY"},
			        ["ArcHUDRing_TargetHealth"] = {"UNIT_HEALTH"},
			        ["ArcHUDRing_TargetMana"] = {"UNIT_MANA", "UNIT_RAGE", "UNIT_ENERGY", "UNIT_FOCUS"},
			        ["ArcHUDRing_PetHealth"] = {"UNIT_HEALTH"},
			        ["ArcHUDRing_PetMana"] = {"UNIT_MANA", "UNIT_RAGE", "UNIT_ENERGY", "UNIT_FOCUS"},
			    },
			};
		end
		if IsAddOnLoaded("TitanRegen") then
			WT_ZoningTimeFix.Addons["TitanRegen"] = {
				Frames = {
					["TitanPanelTitanRegenButton"] = {"UNIT_HEALTH", "UNIT_MANA"},
				},
			};
		end
		if IsAddOnLoaded("Wr") then
			WT_ZoningTimeFix.Addons["Wr"] = {
				Frames = {
					["WrFrame"] = {"UNIT_LEVEL"},
				},
			};
		end
		if IsAddOnLoaded("FlexBar") then
			WT_ZoningTimeFix.Addons["FlexBar"] = {
				Frames = {
					["FlexBar"] = {"UNIT_HEALTH", "UNIT_MANA", "UNIT_AURA", "UNIT_FLAGS"},
				},
			};
			for i = 1, 120, 1 do
				WT_ZoningTimeFix.Addons["FlexBar"].Frames["FlexBarButton"..i] = {"UNIT_HEALTH", "UNIT_MANA"};
			end
		end
		if IsAddOnLoaded("CT_RaidAssist") then
			WT_ZoningTimeFix.Addons["CT_RaidAssist"] = {
				Frames = {
					["CT_RAFrame"] = {"UNIT_HEALTH", "UNIT_MANA", "UNIT_AURA"},
				},
			};
		end
		if IsAddOnLoaded("Perl") then
			WT_ZoningTimeFix.Addons["Perl"] = {
				Frames = {
					["Perl_Raid_Frame"] = {"UNIT_HEALTH", "UNIT_MANA", "UNIT_AURA"},
				},
			};
		end
		if IsAddOnLoaded("MobInfo2") then
			WT_ZoningTimeFix.Addons["MobInfo2"] = {
				Frames = {
					["MI2_MobInfoFrame"] = {"UNIT_HEALTH"},
				},
			};
		end
		if IsAddOnLoaded("MobHealth") then
			WT_ZoningTimeFix.Addons["MobHealth"] = {
				Frames = {
					["MobHealthFrame"] = {"UNIT_HEALTH"},
				},
			};
		end
		if IsAddOnLoaded("WT_RaidWarning") then
			WT_ZoningTimeFix.Addons["WT_RaidWarning"] = {
				Frames = {
					["WT_RaidWarningFrame"] = {"UNIT_HEALTH", "UNIT_MANA", "UNIT_FLAGS"},
				},
				--[[
				Update = {
					{func = WT_RaidWarningAPI.DebugEvent, args = {}},
				},
				--]]
			};
		end
		if IsAddOnLoaded("AllInOneInventory") then
			WT_ZoningTimeFix.Addons["AllInOneInventory"] = {
				Frames = {
					["AIOBFrame"] = {"BAG_UPDATE", "ITEM_LOCK_CHANGED"},
					["AllInOneInventoryItemsFrame"] = {"BAG_UPDATE", "ITEM_LOCK_CHANGED"},
				},
				Update = {
					{func = AllInOneInventoryItemsFrame_DoUpdate, args = {}},
				},
			};
		end
		WT_ZoningTimeFix.Addons["Blizzard_RaidUI"] = {
			Frames = {
				["RaidFrame"] = {"UNIT_HEALTH"},
			},
		};
	end
end

WT_ZoningTimeFix.InjectEventCatcher = function()
	local frame = EnumerateFrames();
	while frame do
		if ((not WarmupFrame) or (frame ~= WarmupFrame)) then
			local onLoadscript = frame:GetScript("OnLoad");
			local onEventscript = frame:GetScript("OnEvent");
			if(onLoadscript and onEventscript) then
				-- save original script
				frame.OriginalScript = onEventscript;
				-- inject event catcher
				frame:SetScript("OnEvent",
					function()
						for suppressedEvent, _ in WT_ZoningTimeFix.SuppressedEvents do
							if (event == suppressedEvent) and this:GetName() then
								if WT_ZoningTimeFix.CapturedFrames[this:GetName()] then
									local hasEvent = false;
									for _, childEvent in WT_ZoningTimeFix.CapturedFrames[this:GetName()] do
										if (event == childEvent) then
											hasEvent = true;
										end
									end
									if not hasEvent then
										tinsert(WT_ZoningTimeFix.CapturedFrames[this:GetName()], event);
										--DEFAULT_CHAT_FRAME:AddMessage(event.." debug");
									end
								else
									WT_ZoningTimeFix.CapturedFrames[this:GetName()] = {};
									tinsert(WT_ZoningTimeFix.CapturedFrames[this:GetName()], event);
								end
							end
						end
						-- self remove when done
						if WT_ZoningTimeFix.SuppressedEventsCount == 0 then
							this:SetScript("OnEvent", this.OriginalScript);
						end
						this.OriginalScript();
					end
				);
			end
		end
		frame = EnumerateFrames(frame);
	end
end

WT_ZoningTimeFix.SuppressedEventsFired = function(event)
	WT_ZoningTimeFix.SuppressedEvents[event] = WT_ZoningTimeFix.SuppressedEvents[event] + 1;
	if WT_ZoningTimeFix.SuppressedEvents[event] == 2 then -- 2ed time fired, remove from list
		WT_ZoningTimeFix.SuppressedEvents[event] = nil;
		WT_ZoningTimeFix.SuppressedEventsCount = WT_ZoningTimeFix.SuppressedEventsCount - 1
		this:UnregisterEvent(event);
		--DEFAULT_CHAT_FRAME:AddMessage(event.." is ready");
	end
	if WT_ZoningTimeFix.SuppressedEventsCount == 0 then
		-- all events have been fired twice, WT_ZoningTimeFix.CapturedFrames is ready for use
		WT_ZoningTimeFix_SavedFrames = WT_ZoningTimeFix.CapturedFrames;
		--DEFAULT_CHAT_FRAME:AddMessage("WT_ZoningTimeFix.CapturedFrames is ready for use");
	end
end